freeslot("sfx_drpdsh")
sfxinfo[sfx_drpdsh].caption = "Drop Dash"


addHook("PlayerThink", function(player)
	if player.charging == nil
		player.charging = false
	end
end)


freeslot(
"S_DROPDASH1",
"S_DROPDASH2",
"S_DROPDASH3",
"S_DROPDASH4",
"S_DROPDASH5",
"S_DROPDASH6",
"SPR_DRPD"
)

states[S_DROPDASH1] = {
	sprite = SPR_DRPD,
	frame = A,
	tics = 1,
	nextstate = S_DROPDASH2
}

states[S_DROPDASH2] = {
	sprite = SPR_DRPD,
	frame = B,
	tics = 1,
	nextstate = S_DROPDASH3
}

states[S_DROPDASH3] = {
	sprite = SPR_DRPD,
	frame = C,
	tics = 1,
	nextstate = S_DROPDASH4
}

states[S_DROPDASH4] = {
	sprite = SPR_DRPD,
	frame = D,
	tics = 1,
	nextstate = S_DROPDASH5
}

states[S_DROPDASH5] = {
	sprite = SPR_DRPD,
	frame = E,
	tics = 1,
	nextstate = S_DROPDASH6
}

states[S_DROPDASH6] = {
	sprite = SPR_DRPD,
	frame = F,
	tics = 1,
	nextstate = S_DROPDASH1
}


addHook("AbilitySpecial", function(player)
	if (player.mo.skin == "sonic")
		and (player.mo.state == S_PLAY_JUMP)
		and not (player.powers[pw_shield])
		and not (player.mo.state == S_PLAY_PAIN)
		and not (player.mo.state == S_PLAY_DEAD)
		and not (player.mo.state == S_PLAY_DRWN)
		player.charging = true
		S_StartSound(player.mo, sfx_drpdsh)
		player.mo.state = S_DROPDASH1
	end
	    if (player.powers[pw_shield])
		and (player.mo.skin == "sonic")
		player.charability = CA_THOK
	end
	    if not (player.powers[pw_shield])
		and (player.mo.skin == "sonic")
		player.charability = CA_NONE
	end	
end)


addHook("PlayerThink", function(player)
	if player.charging
	and not (player.cmd.buttons & BT_JUMP)
	or player.charging
	and P_CheckDeathPitCollide(player.mo, true)
		player.charging = false
		player.mo.state = S_PLAY_JUMP
	end
end)


addHook("PlayerThink", function(player)
	if (player.mo.skin == "sonic")
		and player.charging
		and not P_CheckDeathPitCollide(player.mo, true)
		and (P_IsObjectOnGround(player.mo) or (player.mo.eflags & MFE_JUSTHITFLOOR))
		   S_StartSound(player.mo, sfx_zoom)
		   player.mo.state = S_PLAY_ROLL
		   player.charging = false
		   player.pflags = $|PF_SPINNING
		   P_InstaThrust(player.mo, player.mo.angle, 10*FRACUNIT+player.speed)
		   P_SpawnSkidDust(player, 13*FRACUNIT, sfx_none)
		   P_SpawnSkidDust(player, 13*FRACUNIT, sfx_none)
		   P_SpawnSkidDust(player, 13*FRACUNIT, sfx_none)
	    end
     	   if player.charging
	       and (player.powers[pw_justsprung] or player.mo.eflags & MFE_SPRUNG)
		   player.charging = false
	    end
end)


addHook("PlayerThink", function(p)
	if (p.mo.skin == "sonic")
	and (p.pflags & PF_SPINNING)
	and (p.pflags & PF_JUMPED)
		p.pflags = $ & ~PF_SPINNING
	end
end)